/****************************************************************************
2
**
3
** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
4
** All rights reserved.
5
** Contact: Nokia Corporation (qt-info@nokia.com)
6
**
7
** This file is part of the examples of the Qt Toolkit.
8
**
9
** $QT_BEGIN_LICENSE:LGPL$
10
** No Commercial Usage
11
** This file contains pre-release code and may not be distributed.
12
** You may use this file in accordance with the terms and conditions
13
** contained in the Technology Preview License Agreement accompanying
14
** this package.
15
**
16
** GNU Lesser General Public License Usage
17
** Alternatively, this file may be used under the terms of the GNU Lesser
18
** General Public License version 2.1 as published by the Free Software
19
** Foundation and appearing in the file LICENSE.LGPL included in the
20
** packaging of this file.  Please review the following information to
21
** ensure the GNU Lesser General Public License version 2.1 requirements
22
** will be met: http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
23
**
24
** In addition, as a special exception, Nokia gives you certain additional
25
** rights.  These rights are described in the Nokia Qt LGPL Exception
26
** version 1.1, included in the file LGPL_EXCEPTION.txt in this package.
27
**
28
** If you have questions regarding the use of this file, please contact
29
** Nokia at qt-info@nokia.com.
30
**
31
**
32
**
33
**
34
**
35
**
36
**
37
**
38
** $QT_END_LICENSE$
39
**
40
****************************************************************************/

#ifndef QMAEMO5HOMESCREENADAPTOR_H

#define QMAEMO5HOMESCREENADAPTOR_H


#include <QtCore/qobject.h>

#include <QtCore/qpointer.h>

#include <QtGui/qwidget.h>

class QWidget;

class QSocketNotifier;

class QMaemo5HomescreenAdaptor : public QObject

{

    Q_OBJECT

    Q_PROPERTY(bool settingsAvailable READ settingsAvailable WRITE setSettingsAvailable)

public:

    QMaemo5HomescreenAdaptor(QWidget *widget);

    ~QMaemo5HomescreenAdaptor();

    inline void setSettingsAvailable(bool available)

    {

        hasSettings = available;

        updateStatus();

    }

    inline bool settingsAvailable() const

    {

        return hasSettings;

    }

Q_SIGNALS:

    void settingsRequested();

    void homescreenChanged(bool isOnCurrentHomescreen);

private Q_SLOTS:

    void socketException();

private:

    inline QWidget *appletWidget() const { return static_cast<QWidget *>(parent()); }

    void updateStatus();

    static bool applicationEventFilter(void *message, long *result);

    bool hasSettings;

    QString appletId;

    QSocketNotifier *socketNotifier;

};

#endif
